package com.kexue.skills.mapper;

import com.kexue.skills.entity.PointsAccount;
import com.kexue.skills.entity.dto.PointsAccountDto;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * (PointsAccount)表数据库访问层
 *
 * @author 王志维
 * @since 2025-02-21 23:01:48
 */
@Mapper
public interface PointsAccountMapper {
    /**
     * 分页查询
     *
     * @param queryDto 筛选条件
     * @return 查询结果
     */
    List<PointsAccount> getPageList(PointsAccountDto queryDto);

    /**
     * 查询列表
     *
     * @param queryDto 筛选条件
     * @return 查询结果
     */
    List<PointsAccount> getList(PointsAccountDto queryDto);

    /**
     * 通过主键查询单条数据
     *
     * @param accountId 主键
     * @return 实例对象
     */
    PointsAccount queryById(Long accountId);

    /**
     * 通过用户ID查询积分账户
     *
     * @param userId 用户ID
     * @return 实例对象
     */
    PointsAccount queryByUserId(Long userId);

    /**
     * 新增数据
     *
     * @param pointsAccount 实例对象
     * @return 影响行数
     */
    int insert(PointsAccount pointsAccount);

    /**
     * 更新数据
     *
     * @param pointsAccount 实例对象
     * @return 影响行数
     */
    int update(PointsAccount pointsAccount);

    /**
     * 更新积分
     *
     * @param userId 用户ID
     * @param points 变动积分
     * @param type 变动类型：1.增加 2.减少
     * @return 影响行数
     */
    int updatePoints(@Param("userId") Long userId, @Param("points") Integer points, @Param("type") Integer type);

    /**
     * 通过主键逻辑删除
     *
     * @param accountId 主键
     * @return 影响行数
     */
    int logicDeleteById(@Param("accountId") Long accountId, @Param("updateBy") String updateBy);

    /**
     * 通过主键物理删除
     *
     * @param accountId 主键
     * @return 影响行数
     */
    int deleteById(Long accountId);
}